% produces a profile of Doppler spectra

clear i pi

PRF=610;
lambda=0.09751341;
dp=1;
alpha=lambda*PRF/(4*pi*dp)

width=2; % the standard deviation of the fake signal (m/s)

n=102400
%randn produces a normal distribution, so scale it by width
offset=(width/alpha)*randn(1,n); 
offset1=randn(1,n)*0;
offset2=offset1+cumsum(offset);
hc=cos(offset2+1*(1:n))+i*sin(offset2+1*(1:n));
hc=hc';

%load andy.txt -ASCII; clear i; hc=andy(1:1024)+i*andy(1025:2048)-2048*(1+i);
%hc=floor(hc/100)*100;
[n m]=size(hc);
%Use windowing to get rid of discontinuity at beginning and end
s=n/128;
Welch=(1-(([1:n]-n/2)./(n/2)).^2)'*ones(1,m);
%s=n/64;

P=fft(hc.*Welch);
PP=P.*conj(P);

PP=ave(PP,s); %Smooth the result a bit...

clear P


%now work out the various lags

Rd0=conj(hc(1:end)).*hc(1:end);
Rd0m=mean(Rd0);
S=Rd0m; %the power

Rd1=conj(hc(1:end-1)).*hc(2:end);
Rd1m=mean(Rd1);
vel=-alpha*angle(Rd1m) %Mean velocity 
vels=-alpha*angle(Rd1);

Rd2=conj(hc(1:end-2)).*hc(3:end);
Rd2m=mean(Rd2);

%Calculate Spectral width using two methods:

%p109 of Doviak:
p=abs(Rd1m/S);
sigma1=sqrt(2)*alpha*(log(1/p)^0.5);

sigma1=sqrt(2)*alpha*((abs(1-(1/p)))^0.5);
sigma1
%Singapore code:

sigma2=(2*alpha/sqrt(6))*(abs(log(abs(Rd1m/Rd2m)))^0.5)*2*((log(abs(Rd1m/Rd2m)) > 0)-0.5);
sigma2

%
%sigma3=sqrt(2)*alpha*((abs(1-(abs(Rd2m)/abs(Rd1m))))^0.5)
sigma3=sqrt(2)*alpha*(log(abs(Rd1m)/abs(Rd2m))^0.5)

%Calculate SNR
SNR=(abs(Rd1m)^1.3333)/(Rd0m*(abs(Rd2m)^0.3333)-abs(Rd1m)^1.3333)

%Now we now SNR, recalculate width taking it into account
sigma4=sqrt(2)*alpha*((abs(1-(abs(Rd1m)/abs(Rd0m))*(1+SNR^(-1.0))))^0.5)


%
sigma2a=sqrt(2)*alpha*((abs(1-(abs(Rd1m)/abs(Rd0m))*(1+SNR^(-1.0))))^0.5)
sigma1a=sqrt(2)*alpha*((abs(1-(abs(Rd1m)/abs(Rd0m))))^0.5)



ratio=sigma1/sigma2;
ratio

ratio2=ratio^2;
ratio2




% Compute spectrum.... just for plotting
vfold=PRF.*lambda./4;
[n m]=size(PP);
spec=PP([n/2+1:n 1:n/2+1],:); % rotate the spectrum to get 0 in the
                              % middle
v=-vfold:2.*vfold/n:vfold;

offsetscale=2;%0.75;
%dBperkm=120/diff(rangein([1 2]));

hview=[1:1:m];
noisegate=m;
index=find(v>0.25|v<-0.25);
noise=mean(spec(index,noisegate));
stdn=std(spec(index',noisegate));
index=find(spec<noise+4*stdn);
tspec=spec-noise;
tspec(index)=NaN.*ones(size(index));
%Plot things...
figure(1)
clf
%plot(v,spec,'k');
semilogy(v,spec,'k');





