function vel=unfold2(v,vmin1,vmin2,i);

%unfold2(v,vmin1,vmin2,i): Unfolds doppler velocity data
% Use: vel=unfold2(v,vmin1,vmin2,i)
%  v is the (folded) original data
%  vmin1 and (vmin1+30) give the bounds for v(1:(i-1),:)
%  vmin2 and (vmin2+30) give the bounds for v(i:mm,:)
%      where v = v(1:mm,:)
%  vel is the unfolded output

[mm nn]=size(v);
vel=v;
vf=30;
vmax1=vmin1+vf;
vmax2=vmin1+vf;
corm1=vf*(v(1:(i-1),:)<vmin1)-vf*(v(1:(i-1),:)>vmax1);     %corm1 is the correction matrix in region 1
corm2=vf*(v(i:mm,:)<vmin2)-vf*(v(i:mm,:)>vmax2);     %corm2 is the correction matrix in region 2
vel(1:(i-1),:)=v(1:(i-1),:)+corm1;
vel(i:mm,:)=vel(i:mm,:)+corm2;